VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cINetConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "This class manages the connection to the Internet"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Functions and Subrountines
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
Private Declare Function InternetAttemptConnect Lib "wininet.dll" (ByVal dwReserved As Long) As Long
Private Declare Function InternetCheckConnection Lib "wininet.dll" Alias "InternetCheckConnectionA" (ByVal lpUrl As String, ByVal lpdwFlags As Long, ByVal dwReserved As Long) As Long
Private Declare Function InternetAutodial Lib "wininet.dll" (ByVal dwFlags As Long, ByVal dwReserved As Long) As Long
Private Declare Function InternetAutodialHangup Lib "wininet.dll" (ByVal dwReserved As Long) As Long
Private Declare Function InternetGetConnectedState Lib "wininet.dll" (lpdwFlags As Long, ByVal dwReserved As Long) As Long
Private Declare Function InternetOpen Lib "wininet.dll" Alias "InternetOpenA" (ByVal lpszAgent As String, ByVal dwAccessType As Long, ByVal lpszProxyName As String, ByVal lpszProxyBypass As String, ByVal dwFlags As Long) As Long
Private Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" (ByVal hInet As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInet As Long) As Long

Private Declare Function GetLastError Lib "kernel32" () As Long

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Constants
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
' Flags for InternetAutodial
Private Const INTERNET_AUTODIAL_FORCE_ONLINE = 1            ' Forces an online Internet connection.
Private Const INTERNET_AUTODIAL_FORCE_UNATTENDED = 2        ' Forces an unattended Internet dial-up.
Private Const INTERNET_AUTODIAL_FAILIFSECURITYCHECK = 4     ' The auto dial fails if File and Print sharing is turned on

' InternetOpen Options
Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0              ' use registry configuration
Private Const INTERNET_OPEN_TYPE_DIRECT = 1                 ' direct to net
Private Const INTERNET_OPEN_TYPE_PROXY = 3                  ' via named proxy
Private Const INTERNET_OPEN_TYPE_PRECONFIG_WITH_NO_AUTOPROXY = 4   ' prevent using java/script/INS

' Internet Open Flags
Private Const INTERNET_FLAG_ASYNC = &H10000000
Private Const INTERNET_FLAG_FROM_CACHE = &H1000000
Private Const INTERNET_FLAG_OFFLINE = INTERNET_FLAG_FROM_CACHE

' Flags for InternetGetConnectedState
Private Const INTERNET_CONNECTION_MODEM = 1
Private Const INTERNET_CONNECTION_LAN = 2
Private Const INTERNET_CONNECTION_PROXY = 4
Private Const INTERNET_CONNECTION_MODEM_BUSY = 8

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Constants
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
' AutoDial Flags
Public Enum INetAutodialFlags
   InternetAutodialForceOnline = INTERNET_AUTODIAL_FORCE_ONLINE
   InternetAutodialUnattended = INTERNET_AUTODIAL_FORCE_UNATTENDED
   InternetAutodialFailIfSecurityCheck = INTERNET_AUTODIAL_FAILIFSECURITYCHECK
End Enum

' InternetOpen Connection Types
Public Enum INetOpenConnectionType
    InternetOpenType_PRECONFIG = INTERNET_OPEN_TYPE_PRECONFIG
    InternetOpenType_DIRECT = INTERNET_OPEN_TYPE_DIRECT
    InternetOpenType_PROXY = INTERNET_OPEN_TYPE_PROXY
    InternetOpenType_PRECONFIG_WITH_NO_AUTOPROXY = INTERNET_OPEN_TYPE_PRECONFIG_WITH_NO_AUTOPROXY
End Enum

' Connection States
Public Enum InetConnectionStates
   InternetConnectionModem = INTERNET_CONNECTION_MODEM
   InternetConnectionLan = INTERNET_CONNECTION_LAN
   InternetConnectionProxy = INTERNET_CONNECTION_PROXY
   InternetConnectionModemBusy = INTERNET_CONNECTION_MODEM_BUSY
End Enum

' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
'   Local variable(s) to hold property value(s)
' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
Private mvarConnected           As Boolean
Private mvarConnectionMode      As Long
Private mvarConnectionModeText  As String
Private mvarhInet               As Long
Private mvarINetErrorNumber     As Long

Public Property Get INetErrorNumber() As Long
Attribute INetErrorNumber.VB_Description = "Returns the last Error number returned by one of the Internet Functions"
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.INetErrorNumber
    INetErrorNumber = mvarINetErrorNumber
End Property



Public Property Get hInet() As Long
Attribute hInet.VB_Description = "Returns the handle to the Internet connection."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.hInet
    hInet = mvarhInet
End Property



' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   Connect: Attempts to establish a connection to the Internet
'
'       Parameters: None
'
'       Return: Long, The hanlde to the internet connection if one
'           was established.
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Function Connect(Optional ApplicationName As String = "cINetConnection", _
                        Optional INetOpenConnectionType As INetOpenConnectionType, _
                        Optional ProxyName As String = vbNullString, _
                        Optional ProxyBypass As String = vbNullString, _
                        Optional INetOpenFlags As Long = 0) As Long

    On Error GoTo Connect_Error
    Const cstrProcName      As String = "Connect"
    
    ' The return value from the internet functions
    Dim lngReturn           As Long
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Attempts to make a connection to the Internet.
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    lngReturn = InternetAttemptConnect(0&)
    ' Check to see if we are able to connect
    If lngReturn > 0 Then
        ' The was an error in the InternetAttemptConnect
        mvarINetErrorNumber = lngReturn
        GoTo Connect_Error
    End If
    
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    '   Open the Internet Connection
    ' @~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~@
    mvarhInet = InternetOpen(App.Title, INetOpenConnectionType, ProxyName, ProxyBypass, INetOpenFlags)

    ' Set the Connect Functions return value equal to the mvarhInet
    Connect = mvarhInet
    
Connect_Exit:
    On Error GoTo 0
    Exit Function
    
Connect_Error:
    ShowError cstrProcName
    Resume Connect_Exit
End Function


Public Property Get ConnectionModeText() As String
Attribute ConnectionModeText.VB_Description = "Returns the text description of the connection mode."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ConnectionModeText
    Refresh
    ConnectionModeText = mvarConnectionModeText
End Property



Private Sub Refresh()
   Dim lngINetFlags As Long
   
   mvarConnected = InternetGetConnectedState(lngINetFlags, 0&)
   mvarConnectionMode = lngINetFlags
   
   If lngINetFlags And INTERNET_CONNECTION_MODEM Then
      mvarConnectionModeText = "Modem"
      If lngINetFlags And INTERNET_CONNECTION_MODEM_BUSY Then
         mvarConnectionModeText = "Modem (Busy)"
      End If
   ElseIf lngINetFlags And INTERNET_CONNECTION_LAN Then
      mvarConnectionModeText = "LAN"
   ElseIf lngINetFlags And INTERNET_CONNECTION_PROXY Then
      mvarConnectionModeText = "Proxy Server"
   End If
   
End Sub
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   ShowError: Raises a Visual Basic runtime error
'
'       Parameters: ProcedureName, string; The procedure that is
'           generating the error.
'
'       Return: Long, The handle to the internet connection if one
'           was established.
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Private Sub ShowError(ProcedureName As String)

    Err.Raise Err.Number, "cINetConnection!" & ProcedureName, Err.Description
    
End Sub

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   AutoDial: Dials the Internet Connection based on the flags
'       specified in Flags
'
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Public Function AutoDial(Optional Flags As INetAutodialFlags = InternetAutodialUnattended) As Boolean
Attribute AutoDial.VB_Description = "Attempts to connect to the Internet using a Dial-up connection."
   
   If Not Connected Then
      If CBool(InternetAutodial(Flags, 0&)) Then
         AutoDial = True
      Else
         ' Debug.Print WinInetErrorTextEx(Err.LastDllError)
         AutoDial = False
      End If
   End If
End Function

Public Function HangUp() As Boolean
Attribute HangUp.VB_Description = "Hangs up a dialed up Internet connection"
   If Connected Then
      HangUp = CBool(InternetAutodialHangup(0&))
   Else
      HangUp = False  ' maybe should be True???
   End If
End Function


Public Property Get ConnectionMode() As Long
Attribute ConnectionMode.VB_Description = "Returns the value for the connection mode"
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.ConnectionMode
    Refresh
    ConnectionMode = mvarConnectionMode
End Property





Public Property Get Connected() As Boolean
Attribute Connected.VB_Description = "Returns the connection state of the Internet connection"
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Connected
    Refresh
    Connected = mvarConnected
    If mvarConnected = True And mvarhInet = 0 Then
        ' Open the internet connection
        mvarhInet = InternetOpen(App.Title, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0&)
    End If
End Property



Private Sub Class_Terminate()

    If hInet <> 0 Then
        ' Close the Internet connection
        Call InternetCloseHandle(hInet)
    End If
    
End Sub


