VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cURL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "A URL Class"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Private mvarURL As String 'local copy
Private mvarTitle As String 'local copy
Private mvarhInet As Long 'local copy
Private mvarKeywords As String 'local copy
Private mvarDescription As String 'local copy
Private mvarAuthor As String 'local copy
Private mvarBodyText As String 'local copy
Private mvarHeadText As String 'local copy
Private mvarHTMLText As String 'local copy
Private mvarhURL As Long 'local copy
Private mvarLinks   As cLinks

Private Declare Function InternetOpenUrl Lib "wininet.dll" Alias "InternetOpenUrlA" (ByVal hInet As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetReadFile Lib "wininet.dll" _
   (ByVal hFile As Long, ByVal sBuffer As String, _
   ByVal lNumberOfBytesToRead As Long, _
   lNumberOfBytesRead As Long) As Integer
Private Declare Function InternetCloseHandle Lib "wininet.dll" (ByVal hInet As Long) As Long
Public Function GetLinks() As Boolean

    Dim strWorkstring   As String
    Dim strLinkString   As String
    Dim lngStartPos     As Long
    Dim lngEndPos       As Long
    Dim lngStartHref    As Long
    Dim lngEndHref      As Long
    Dim strHref         As String
    Dim strName         As String
    
    Dim objLink         As cLink
    
    Const cstrStartA    As String = "<A"
    Const cstrEndA      As String = "</A>"
    
    On Error GoTo GetLinks_Error
    Const cstrProcName      As String = "GetLinks"
    
    strWorkstring = UCase$(mvarBodyText)
    
    lngStartPos = InStr(strWorkstring, cstrStartA)
    
    Do Until lngStartPos = 0
        ' Find the end of the <A> tag
        lngEndPos = InStr(lngStartPos + 2, strWorkstring, cstrEndA)
        
        ' No ending string was found
        If lngEndPos = 0 Then
            lngEndPos = Len(strWorkstring)
        End If
        
        ' Build a string that contains all of the text with the <A and </A>
        strLinkString = Mid$(mvarBodyText, lngStartPos + 2, lngEndPos - lngStartPos - 2)
        
        lngStartHref = InStr(UCase$(strLinkString), "HREF=" & Chr$(34))
        If lngStartHref = 0 Then
            ' Try the '
            lngStartHref = InStr(UCase$(strLinkString), "HREF='")
        End If
        lngEndHref = InStr(lngStartHref + 7, UCase$(strLinkString), Chr$(34))
        If lngEndHref = 0 Then
            'Try the '
            lngEndHref = InStr(lngStartHref + 7, UCase$(strLinkString), "'")
        End If
        strHref = Mid$(strLinkString, lngStartHref + 6, lngEndHref - lngStartHref - 6)
        strName = Mid$(strLinkString, InStr(strLinkString, ">") + 1)
        
        ' Create the Link Object
        Set objLink = New cLink
        With objLink
            .FullText = strLinkString
            .URL = strHref
            .LinkText = strName
        End With
        mvarLinks.Add objLink
        
        Set objLink = Nothing
        DoEvents
        
        ' Look for the next <A
        lngStartPos = InStr(lngEndPos + 4, strWorkstring, cstrStartA)
        
    Loop

    GetLinks = True
    
GetLinks_Exit:
    On Error GoTo 0
    Exit Function
    
GetLinks_Error:
    ShowError cstrProcName
    Resume GetLinks_Exit
End Function

Public Property Get Links() As cLinks
    Set Links = mvarLinks
End Property

' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
'   ShowError: Raises a Visual Basic runtime error
'
'       Parameters: ProcedureName, string; The procedure that is
'           generating the error.
'
'       Return: Long, The handle to the internet connection if one
'           was established.
' #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
Private Sub ShowError(ProcedureName As String)

    Err.Raise Err.Number, "cLink!" & ProcedureName, Err.Description
    
End Sub

Public Function GetText() As Boolean
Attribute GetText.VB_Description = "This method retrieves the text that populates all of the properties for the URL class"

    Dim strReadBuffer           As String * 4096     ' Grab 4k at a time
    Dim strBlankStr             As String * 4096
    Dim lngNumberOfBytesRead    As Long
    Dim bolDoLoop               As Boolean
    
    ' Clear the previous text property
    mvarHTMLText = ""
    
    ' Get the HTML Text from the URL
    bolDoLoop = True
    While bolDoLoop
        ' Reintialize the Read Buffer
        strReadBuffer = strBlankStr
        ' Read from the URL
        bolDoLoop = InternetReadFile(mvarhURL, strReadBuffer, _
            Len(strReadBuffer), lngNumberOfBytesRead)
        ' Add the returned text to the text property
        mvarHTMLText = mvarHTMLText & Left$(strReadBuffer, lngNumberOfBytesRead)
        If Not CBool(lngNumberOfBytesRead) Then bolDoLoop = False
        DoEvents
    Wend
    
    ' If we have returned so text then the
    If Len(Trim$(mvarHTMLText)) = 0 Then
        GetText = True
        Exit Function
    End If
    
    ' get the main properties
    mvarHeadText = ParseTag(mvarHTMLText, "HEAD")
    mvarBodyText = ParseTag(mvarHTMLText, "BODY")
    
    ' Get all of the sections under the Head section
    mvarTitle = ParseTag(mvarHeadText, "TITLE")
    mvarKeywords = ParseMETATag(mvarHeadText, "KEYWORDS")
    mvarAuthor = ParseMETATag(mvarHeadText, "AUTHOR")
    mvarDescription = ParseMETATag(mvarHeadText, "DESCRIPTION")
    
    
End Function

Private Function ParseMETATag(InText As String, MetaTag As String) As String

    Dim lngStartPos     As Long
    Dim lngEndPos       As Long
    
    Dim strTemp         As String
    Dim strWorkstring   As String
    Dim strWorkstring2  As String ' for the CONTENT=
    
    strWorkstring = "<META NAME=" & Chr$(34) & UCase$(MetaTag) & Chr$(34) & " CONTENT="
    
    
    strTemp = UCase$(InText)
    
    lngStartPos = InStr(strTemp, strWorkstring)
    If lngStartPos = 0 Then
        ' The head section was not found
        ParseMETATag = ""
    Else
        lngEndPos = InStr(lngStartPos + Len(strWorkstring) + 1, strTemp, Chr$(34) & ">")
        ParseMETATag = Mid$(InText, lngStartPos + Len(strWorkstring) + 1, lngEndPos - lngStartPos - Len(strWorkstring) - 1)
    End If

End Function

Private Function ParseTag(InText As String, Section As String) As String

    Dim lngStartTagPos  As Long
    Dim lngEndTagPos    As Long
    Dim lngTagEndSign   As Long
    
    Dim strTemp         As String
    
    strTemp = UCase$(InText)
    
    lngStartTagPos = InStr(strTemp, "<" & Section & "")
    
    
    If lngStartTagPos = 0 Then
        ' The head section was not found
        ParseTag = ""
    Else
        lngTagEndSign = InStr(lngStartTagPos, strTemp, ">")
        lngEndTagPos = InStr(lngTagEndSign + 1, strTemp, "</" & Section & ">")
        ParseTag = Mid$(InText, lngTagEndSign + 1, lngEndTagPos - lngTagEndSign - 1)
    End If

End Function


Public Function VerifyExistance() As Boolean
Attribute VerifyExistance.VB_Description = "Verifies the URL exists."

    Const INTERNET_FLAG_RELOAD = &H80000000 'read from wire even if locally cached
    Const INTERNET_FLAG_KEEP_CONNECTION = &H400000    '// use keep-alive semantics
    Const INTERNET_FLAG_NO_CACHE_WRITE = &H4000000    '// don't write this item to the cache
    Const lngFlags = INTERNET_FLAG_KEEP_CONNECTION Or INTERNET_FLAG_NO_CACHE_WRITE Or INTERNET_FLAG_RELOAD

    If mvarhInet = 0 Then
        Err.Raise vbObjectError + 1, "cURL", "A valid Internet handle was not supplied"
        Exit Function
    End If
    
    '
    ' Check the URL
    '
    mvarhURL = InternetOpenUrl(mvarhInet, CStr(mvarURL), vbNullString, 0, lngFlags, 0)
    If mvarhURL Then VerifyExistance = True


End Function



Public Property Get hURL() As Long
Attribute hURL.VB_Description = "Returns the handle to the URL"
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.hURL
    hURL = mvarhURL
End Property



Public Property Let HTMLText(ByVal vData As String)
Attribute HTMLText.VB_Description = "Returns/Sets the text of the URL"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.HTMLText = 5
    mvarHTMLText = vData
End Property


Public Property Get HTMLText() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.HTMLText
    HTMLText = mvarHTMLText
End Property



Public Property Let HeadText(ByVal vData As String)
Attribute HeadText.VB_Description = "Returns/Sets the <HEAD> text for this URL."
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.HeadText = 5
    mvarHeadText = vData
End Property


Public Property Get HeadText() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.HeadText
    
    HeadText = mvarHeadText
End Property



Public Property Let BodyText(ByVal vData As String)
Attribute BodyText.VB_Description = "Returns/Sets the <BODY> section of this URL"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.BodyText = 5
    mvarBodyText = vData
End Property


Public Property Get BodyText() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.BodyText
    BodyText = mvarBodyText
End Property



Public Property Let Author(ByVal vData As String)
Attribute Author.VB_Description = "Returns/Sets the Author of this URL"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Author = 5
    mvarAuthor = vData
End Property


Public Property Get Author() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Author
    Author = mvarAuthor
End Property



Public Property Let Description(ByVal vData As String)
Attribute Description.VB_Description = "Returns/Sets the description for this URL"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Description = 5
    mvarDescription = vData
End Property


Public Property Get Description() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Description
    Description = mvarDescription
End Property



Public Property Let Keywords(ByVal vData As String)
Attribute Keywords.VB_Description = "Returns/Sets the Keywords for this URL"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Keywords = 5
    mvarKeywords = vData
End Property


Public Property Get Keywords() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Keywords
    Keywords = mvarKeywords
End Property




Public Property Get hInet() As Long
Attribute hInet.VB_Description = "Sets the Internet Handle to use."
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.hInet
    hInet = mvarhInet
End Property



Public Property Let hInet(vData As Long)
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: X.hInet = 5
    mvarhInet = vData
End Property
Public Property Let Title(ByVal vData As String)
Attribute Title.VB_Description = "Returns/Sets the title for this URL"
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Title = 5
    mvarTitle = vData
End Property


Public Property Get Title() As String
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Title
    Title = mvarTitle
End Property



Public Property Let URL(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.URL = 5
    mvarURL = vData
End Property


Public Property Get URL() As String
Attribute URL.VB_Description = "Returns/Sets the Uniform Resource Locator"
Attribute URL.VB_UserMemId = 0
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.URL
    URL = mvarURL
End Property



Private Sub Class_Initialize()
    Set mvarLinks = New cLinks
End Sub

Private Sub Class_Terminate()
    If mvarhURL <> 0 Then Call InternetCloseHandle(mvarhURL)
    Set mvarLinks = Nothing
End Sub


